function [v]=soldi(s0,nc,n)

/////////////////////////////////////////////////////////////////////////////
//
// Simulazione roulette
// Copyright (C) 2000 Bellotti Stefano <signo@lugbs.linux.it>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////

 //s0=soldi iniziali
 //n=numero giocate
 //nc=numero di volte consecutive dell'uscita di un colore, prima che si punti sull'altro

 v(1)=s0;
 puntata=0;
 cons=0;
 colprec=caso();
 correnti=s0;

 for i=2:n
  col=caso();
  if puntata==0 then
   //non ho ancora puntato
   if (col>0 & colprec>0 & modulo(col,2)==modulo(colprec,2)) then
    //uscito stesso colore di prima
    cons=cons+1;
    if cons==nc then
     //raggiunto quota colori uguali per puntare
     cons=0;
     puntata=1;
     correnti=correnti-1;
    end
   else
    //uscito un colore diverso
    cons=0;
   end
  else
   //avevo puntato
   if (col>0 & colprec>0 & modulo(col,2)~=modulo(colprec,2)) then
    //ho vinto
    correnti=correnti+puntata*2;
    puntata=0;
   else
    //ho perso
    puntata=2*puntata;
    correnti=correnti-puntata;
   end
  end
  colprec=col;
  v(i)=correnti;
 end
endfunction

function [x]=caso()
 x=int(rand(1,1)*37);
endfunction
